import { Driver } from "./Driver";
import { TruckState } from "./TruckState/TruckState";
import { InBaseState } from "./TruckState/state/InBaseState";

export class Truck {
    id: number;
    name: string;
    driver: Driver;
    private _state: TruckState;
    private _stringState: string;

    constructor (id: number, name: string, driver: Driver) {
        this.id = id;
        this.name = name;
        this.driver = driver;
        this._state = new InBaseState();
        this._stringState = this._state.name;
        this._state.setTruck(this);
    };

    changeState (state: TruckState) {
        this._state = state;
    };

    getInfoAll (): void {
        console.log(`${this.id} | ${this.name} | ${this.driver.name} | ${this._state.name}`);
    };

    getInfoSolo (): void {
        console.log(`Айди: ${this.id} \nГрузовик: ${this.name} \nВодитель: ${this.driver.name} \nСостояние: ${this._state.name}`);
    };
};